#include <built_in.h>

unsigned short  DAC_val=1;
unsigned short  DAC_step=1;
float DAC_fval=0.0;

// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

char txt1[] = "Tension (V): ";
char txt2[16];

// Tension de sortie
const float Res_5=5000;
const float Courant_LSB=7.8125E-6;
float Tension=0.0;

void main()
{
     // Configure AN pins as digital
     ANSEL  = 0;
     ANSELH = 0;

     // Port A en entre
     TRISA=0xFF;

     // Configuration en sortie des ports
     TRISB=0;
     TRISC=0;
     TRISD=0;
     TRISE=0;

     // Initialisation LCD
     Lcd_Init();                     // Initialize Lcd
     Lcd_Cmd(_LCD_CLEAR);            // Clear display
     Lcd_Cmd(_LCD_CURSOR_OFF);       // Cursor off
     Lcd_Out(1,2,txt1);              // Write text in first row


     // Lecture et affichage de la donne ADC
     while(1)
     {
      // Lecture des entres & Mise  jour DAC
      if (Button(&PORTA, 0, 1, 1))
      {
         // Mise  jour  de valeur du DAC
         DAC_val=DAC_val+DAC_step;

         // Affectation de la valeur
         PORTD=DAC_val;

         // Effacer LCD
         Lcd_Cmd(_LCD_CLEAR);

         // Tempo
         Delay_ms(200);
      }
      if (Button(&PORTA, 1, 1, 1))
      {
         DAC_val=DAC_val-DAC_step;
         PORTD=DAC_val;
         Lcd_Cmd(_LCD_CLEAR);
         Delay_ms(200);
      }

      // Conversion Int ==> Float
      DAC_fval=(float)DAC_val;

      // Calcul de la Tension de sortie
      Tension=DAC_fval*Res_5*Courant_LSB;

      // Conversion Float ==> String
      FloatToStr(Tension,txt2);

      // Affichage
      Lcd_Out(1,2,txt1);
      Lcd_Out(2,2,txt2);
     }
}